Dim Shared as Integer nbytes, opflag, recflag
Dim Shared as String ss, rsin, pname, frec

'''''''''''''''''''''''''''''''''''''
''  MAIN  PROGRAM  - E.Ficara 2011 ''
'''''''''''''''''''''''''''''''''''''

    pname = "COM4" ' default com port
    do
        opflag = 1 ' set default flag: open port success
        open com pname & ":115200,N,8,1,CS,DS,CD,RS,TB128,RB256,BIN,FE,ME" for random as #1
        if err <> 0 then
            print "Error opening serial port " & pname
            opflag = 0 ' open port failed
            input "Type another port (i.e. COM11) or <cr> to exit  > ", pname
            if pname = "" then end
        end if
    loop until opflag > 0
    print "......................................"
    print "Minimal Terminal V0.02 - E.Ficara 2011"
    print " press ESC to terminate               "
    print " press Ctrl-R to start/stop recording "
    print "......................................"
    print #1, chr(0); ' serial out (for cleaning)
    recflag = 0 ' default flag state is: not recording
    do
        nbytes = loc(1) ' read num of bytes pending on serial
        if nbytes > 0 then
            rsin = input(nbytes, 1)
            print rsin; ' update screen with received data
			if recflag then print #55,rsin; ' update file if recording
        end if
        ss = inkey$
        if ss <> "" then
            if ss = chr(27) then ' if ESC pressed
                Exit Do ' terminate
            elseif ss = chr(&H12) then ' if <ctrl-r> (start/stop recording>)
				recflag = recflag xor 1 ' toggle recflag status
				if recflag then ' if recording start
					frec = "log_" & str(int(timer)) &".txt" ' create new filename
					print chr(13);chr(10);"Log file name = "; frec
					open frec for output as #55 ' try to open output file
					if err then
						print "Error opening file. Recording cancelled."
						recflag = 0 ' clear flag
					else
						print "Recording started..."
					end if
				else ' if recording stop
					print chr(13);chr(10); "...Recording stopped."
					close #55 ' close output file
				end if
            else ' any other character
                print #1,ss; ' send to serial port
            end if
        end if 
    loop
    close #1
    end
